---
title: 2023年年终总结
date: 2024-02-29T20:18:19.0000000
tags:
- 杂谈
- 年终总结
---


虽然2023年已经过去了两个月，但是年终总结还是要发的。

<!--more-->

### 奋进的一年

虽然2022年在混乱中落幕，没有为2023年的开幕“奠定一个良好的基础”，但在呈上启下之际，我们采取果断措施，及时适应当前的新形势和新环境，成功调整好自己的各种状态。在2023年的工作和学习中取得良好的成绩。

在年初，整个人处在消极和悲哀的环境中。从外部大环境上看，疫情防控开始转段，正常的工作和学习节奏被打乱——或者说整个2022年最缺少的东西就是确定性；从个人小环境上看，2022年年中同高中的女朋友分手，秋季学期存在着离散数学下、数据结构两门我没有学懂的课程，学习和生活环境也从条件较好的新校区变成条件较差的本部校区，还附带着寝室重新组合等等一系列问题。令人感到遗憾的是，面对艰难繁重的工作任务，我并没有及时调整好心态，反而陷入“面临失败——状态下滑——更加失败”下降螺旋中。上述问题造成最直接的结果就是在大二的上学期取得了大学以来最差的成绩。

2023年就是在这种环境中开始，幸而从2023年开始调整自己的状态：一是在变化多端的环境中寻找一个长期性的目标，紧紧围绕这个目标进行工作，给予自己确定性；二是主动切断各类社交媒体和零散信息源，避免自己接触各种无意义的焦虑和内耗消息；三是培养自己阅读的习惯。

从春季学期的成绩来说还是取得了一定的成绩：从需要考试的课程上来看，除了计算机组成原理这门课程的成绩不算理想，计算机网络和形式语言与自动机两门课程还是取得个人较为满意的成绩，而且最重要的是三门课程都还是学的比较透彻。从含有大作业的实践课程上看，数据结构的课程设计让我第一次完整实现了一个前后端分离的应用程序，计算机网络的课程设计锻炼了基于`C`的网络编程，而面向对象的程序设计和形式语言与自动机的实验则在`Java FX`和`Electron`等其他技术领域进行了探索。而在技术之外，通过多次大作业的合作锻炼了一个合作良好的团队——[post-guard](https://github.com/post-guard)。

相对于寒假，暑假则是一个非常充实的。在暑假开始之初前往南京“处理历史遗留问题”，在回到家之后又找了一个事业单位的信息科见习，在各种意义上提高了自己对于世界的认识。同时通过大创项目进入实验室中学习，开始第一次“体验”科研。

在秋季学期中，面对着操作系统、编译原理、数据原理和算法分析四门重量级的课程和为数不少的选修课，我们延续上学期调整好的状态积极进行面对，取得了良好的成绩。在开学之初参加数学建模比赛获得一个安慰奖，为数学竞赛和物理竞赛贡献了不少的报名费，在这些学科竞赛中虽然没有取得很好的成绩，但是参加这些赛事的经历本身也是一种非常难得的锻炼。

在2024年中，我们利用好在2023年奠定的良好基础，赓续奋发图强的精神动力，更加从容自信地面对前进道路上的各种困难。

### 技术上的进展

虽然2023年是在学习上非常忙的一年，但是在技术上还是取得不少的进展。

第一是基本确定了自己的技术路线：以.NET为中心技术，在底层开发上练习使用Rust语言，在前端界面上练习使用React。如此三个方向的进展基本覆盖了计算机开发技术的所有方面。.NET作为一门较为冷门的面对对象开发语言，有着广泛的应用场景，在国内尤其是在工控上位机领域应用广泛。Rust作为C++语言的上位替代，有着极高的性能和开发难度，因此我目前主要作为刷算法题的语言使用。React是目前（个人认为）最主流的前端开发框架，我也很喜欢其函数式的界面设计思想。

第二是将自己的工作环境基本迁移到Linux系统中。Linux作为现代程序运行的主流环境有着很多的好处和坏处：好处是对于各种开发工具的兼容性都非常好，坏处是图形用户界面是一坨屎。因此，我的系列博客“日用Linux挑战”还在火热连载中！

第三是我和同学合资购买了一台二手服务器。在这台服务器上我们部署了各种各样的服务和应用，在很大程度上重塑了我的开发工作流乃至于不少生活习惯。鉴于这一点有点离题，我会单开一篇文章进行介绍（开始挖坑）。

展望2024年的技术前进方向，我们希望向语言和系统更深的地方进军。深入研究.NET运行时的方方面面，兼顾熟悉在.NET生态系统中的各种常用框架技术。尝试推动将Rust语言从算法界面普及到实际应用开发场景中去，以嵌入式开发和操作系统开发等为抓手，逐渐取代C++语言之前在开发技术工具箱中的地位。对于React，在目前所有东西都运行在浏览器上的大环境下，完全不懂任何前端显然是不合理的，因此合理适度的学习相关知识是必不可少的。

之于Linux，我希望继续坚持使用Linux。在日常使用的过程中，尝试将上述各种技术同Linux的系统开发和应用开发结合起来，为不断完善Linux做出一点贡献。

### 其他有趣的方面

2023年最令我吃惊的事情是我刷B站的时长：

![image-20240303165826486](2023-final/image-20240303165826486.webp)

容易计算得出，我一共看了64天的B站，接近六分之一的时间都在看。虽然我确实有着在干活的时候黑听B站和把B站当作音乐播放器的习惯，但是这个时间未免有点太长了。下一年一定要在这个方面做出一定的改变，将更多的时间放在看书上面去，~~虽然写这句话的时候我就在黑听B站~~。

说到看书，在这一年内看来不少的书。在这学期看的最多的还是各种日式轻小说。总体上来说作为一个死宅，我对于各种校园恋爱题材的轻小说还是比较感兴趣的，本年度看完的就有：《我的青春恋爱物语果然有问题》，《路人女主的养成方法》，《继母的拖油瓶是我的前女友》，《关于邻家的天使大人不知不觉把我变成废人这件事》。不过对于各种涉及到世界观的日轻作品我就比较拒绝了，感觉不带脑子看还行，带脑子就有点不行，不过应该还是有不少优秀的作品等待我发现。在中文小说上，这年度应该就看了两本：《北平无战事》和《临高启明》，虽然这两本书在各种意义上差距都有点大。在各种专著上我的兴趣点也不少，比较好看的有《美国反对美国》和《筚路蓝缕 世纪工程决策建设记述》，比较枯燥的有《当代中国政府与政治》和《走向自主创新：寻求中国力量的源泉》和《新火（走向自主创新2）》。不过后面两本工业调查报告如果看进去了还是比较上头的，那种工业上“冷峻的热血”非常激动人心。

还有不少优秀的电视剧作品。例如《大决战》三部曲和《决战之后》这几部描写解放战争的老电视剧，《三体》这个新锐电视剧虽然在节奏上有点拖沓，但是各种大场面的观感不错和合理的改变还是不错的。
