---
title: 日用Linux挑战 第1篇 问题与挑战
tags:
  - Linux
  - 杂谈
date: 2023-03-08 22:37:29
---


从去年12月底正式切换到`Linux`开始算起，我日常使用`Linux`已经过去了2个月的时间。在本系列的上一篇文章——[日用Linux挑战 第0篇 - Ricardo的博客](https://rrricardo.top/blog/2023/01/15/daily-linux-0/)中，我讲述了我配置自己的`Arch Linux`的过程，还小小的赞扬了一波`Linux`在近些年来取得的进展。但是在这篇文章中，我将重点指出日常使用过程中遇到的问题和困难。

<!--more-->

## 尝试迁移到Wayland

众所周知，`X11`已经是一个落后和过时的显示协议，目前更新的显示协议`Wayland`正在尝试干掉它，但是由于`X11`长期使用带来的稳定性，这种工作并不是那么容易。现在是2023年，`Wayland`的工作进展到了何种程度？

我使用`KDE`作为我的桌面环境。`KDE`已经有了基础的`Wayland`支持，在启动界面选择`Wayland`会话就可以正常进入。

虽然在切换到`Wayland`会话之后，除了`KDE` 自带的应用程序，日常使用的大部分应用程序还是运行在`xwayland`之下，例如`edge`和`firefox`浏览器，`VSCode`等。

在`/etc/environment`中设置`MOZ_ENABLE_WAYLAND=1`可以`firefox`切换到`Wayland`会话下，运行正常。

在`~/.config/microsoft-edge-stable-flags.conf`添加`--ozone-platform-hint=auto`将`edge`切换到`Wayland`下，运行正常。

然而存在的问题也不少。

- `sddm`窗口管理器在关机的时候没法正常的关闭，导致每次关机都需要等待1分30秒。
  
  而且这是一个`sddm`的问题，从[相关Issue](https://github.com/sddm/sddm/issues/1476)上看，这个问题已经在`master`分支被修复了，只是在相关发行版中还没有修复。
  
  采用切换到`sddm-git`的方式修复了这个问题。
  
  > 而且在`archlinuxcn`仓库里面还有这个包，赞美`archlinuxcn`。

- `ibus-rime`输入法在`Wayland`下的适配也是非常的糟糕，甚至是一种不稳定的糟糕，每次出现的问题都不一样，比如现在的问题就是在`Edge`浏览器下无法使用。
  
  在更换使用`fcitx-rime`框架之后稍微好了一点，至少能用了（

- 部分网站的登录信息丢失。

- 使用`BiliBili`全屏播放视频的时候，只要鼠标移入全屏的范围，画面就会黑屏。可能和我使用双显示器有一定的关系。

- 使用`125%`的整体缩放比例的时候，字体处于一种模糊的状态，看上去很不舒服。

简单的说，我不认为现在`Linux`已经准备好切换到`Wayland`下了。

> 听说最新的`Ubuntu 22.04`已经默认使用`Wayland`作为显示协议了，等我有了其他的电脑可以试一试，看看商业公司的加入能不能带来一点转机。

## 使用中发现的问题

### 双屏使用的问题

最近入手了一块2K 75Hz的VA显示屏，本来打算美滋滋的使用双屏高效率的~~摸鱼~~学习，结果发现问题实在是非常的一言难尽。

- 我的两块屏幕的分辨率不是完全一致的，笔记本自带的屏幕是3:2的2160x1440，而新买的显示屏是16:9的2560x1440。这就导致两块屏幕的纵向分辨率是一致的，而横向分辨率是不同，这点似乎迷惑了`KDE`的相关处理程序，导致两块屏幕各有一个部分显示在另外一块屏幕上~~虽然有点抽象，但是我相信你能够想象出来，如果我再次遇到我一定会补一张图的~~。虽然这个问题通过重新设置`Display configuration`就可以解决，但是真的很好笑。

- 部分程序也会因为上面的分辨率不同而导致部分意料之外的情况。比如原神，不如画面整体被横向压缩而出现一大堆椭圆，就是画面的两端有黑边，导致现在我玩原神都是合上笔记本显示屏玩。

> 看来以后想在`Linux`想使用双屏需要购买两块分辨率完全一致的显示屏。

- 程序在两块屏幕上的显示完全是混乱的。比如我打开`IDEA`，启动界面显示在一块屏幕上，选择项目之后的编辑界面又会出现在另外一块屏幕上。

### Wine`键盘按键不停重复的问题

在某次`sudo pacman -Syu`之后，我遇到一个奇怪的现象——在打原神的时候，如果较长时间的按下某一个按键，那么那个按键就会不停的重复，就像没有弹起一样。例如我按下`W`键较长时间再松开，人物仍然会前进，就像我没有松开一样。

当时我的解决办法是在系统设置里临时关闭了`When a key is held`选项再进行游戏。通过查看`pacman`的更新日志，我以为是`plasma`更新的问题。

在之后的某天中，为了折腾`Wayland`，我把输入法从`ibus`框架切换到了`fcitx5`框架，惊喜的发现这个问题消失了。

那么新的问题出现了：这个问题到底是为啥出现捏？不过本着多一事不如少一事的精神，我选择能跑就行，管它为什么。

## 赞美Kde Connect

作为一个大学牲，在自己的不同设备之间频繁的传送文件自然是家常便饭。在进入`Linux`之前，我几乎都是使用`QQ`在我的手机、iPad和笔记本电脑之间共享文件，属于是究极折磨。入境大力拥抱`Linux`和`KDE`，没想到还有意外收获——`KDE connect`。在手机和iPad和笔记本电脑上安装和互相配对之后，不同的设备之间就可以方便的发送和接受文件了。妈妈再也不同担心我传送文件的难题了。

好了下次攒够一波问题和经历在更新新一期Linux日用挑战。
