---
title: 大学生用啥配置——计算机专业
date: 2022-06-13T16:17:27.0000000
tags:
- 杂谈
---



> 本文是应B站UP主[远古时代装机猿](https://space.bilibili.com/35359510)发起的[大学生用啥配置](https://www.bilibili.com/video/BV1kZ4y1i7Le)公益活动而写
>
> 目前某不知名211大学计算机专业在读
>
> 同时也是给我的许多即将选择计算机专业的同学做一个参考

<!--more-->

## 专业需求

### 操作系统

对于大学生来说，还是一台`Windows`系统的电脑更加的适合，理由如下：

- 在学校中的大多人都是使用`Windows`系统，老师的教学设计也是以同学们拥有一台`Windows`系统的电脑为基础的，如果你在学习过程中遇到了一些`MacOS`系统所特有的问题，可能连可以问的人都没有。
- 在学习过程中可能会遇到一些课程需要使用只有`Windows`版本的软件，如果你购买了一台苹果电脑，遇上这种时候就只能使用学校提供的机房或者是安装虚拟机了。

### 常用软件

目前我经常使用的软件如下所示：

- [VSCode](https://code.visualstudio.com/)微软出品的文本编辑器，是我目前使用最多的软件之一。我用它来写简单的`C/C++`,`Python`和`latex`等。
- [Visual Studio](https://visualstudio.microsoft.com/zh-hans/vs/)~~宇宙第一IDE~~用来写`C#`。
- [PyCharm](https://www.jetbrains.com/pycharm/)用来写比较复杂的`Python`项目。
- [CLion](https://www.jetbrains.com/clion/)用来写大型的`C/C++`项目。
- [WebStorm](https://www.jetbrains.com/webstorm/)用来写网页。
- [Android Studio](https://developer.android.google.cn/studio/)用来开发安卓应用。
- [WSL](https://docs.microsoft.com/zh-cn/windows/wsl/about)在`Windows`系统上使用`Linux`的神器，其实质上就是一个虚拟机，不过需要的性能少于传统的虚拟机。

还有一系列日常软件像`QQ`啥的就不列出了，但凡是台电脑也不至于运行不起来。

> 严格来说，我还是有相当多的“常用”软件没有提及，像C语言编译器`MinGW GCC`这类的工具，不过这类命令行工具对性能的需求不容易体现出来，就在下文中对应的IDE处提及了。

### 日常使用场景的列举

> 列举了一些专业学习中常见的一些使用场景，记录了对应性能占用，使文章显得有理有据（确信）
>
> 可直接跳转到分析部分

#### 学习、编写`C/C++`程序

打开`WSL `,`VSCode`和一大堆的网页。

目前的性能占用如图所示

![](c.webp)

在编译代码时CPU占用会有一个短时的提升，不过由于目前编写的程序都较为简单，编译转瞬就完成了。

#### 编写较为复杂的`C/C++`项目

以我目前的C语言大作业为例，打开两个`CLion`进行开发，同时打开一大堆网页查资料。

性能的占用如图所示

![](clion.webp)

在刚打开项目和编译整个项目时CPU的占用会上升，但在完成之后，CPU的占用就会回落。

目前项目的代码量在50000+，编译整个项目需要15秒左右，但是大部分的代码都是引用的库，只需要编译一次，后续的修改只用编译2~3秒就可以。 

#### 编写`C#`项目

通过安装了`Reshaper`插件的`Visual Studio`打开`WPF`应用进行开发，同时也是打开一大堆浏览器标签页查资料。

性能占用如图所示

![](csharp.webp)

#### 写网站

打开`WebStorm`编写网站。

性能占用如图所示：

![](web.webp)

### 软件的运行需求分析

目前我常用的软件以吃CPU和内存为主，对于显卡的需求相对来说不大。

CPU的占用主要出现在打开项目和编译项目上，不同CPU的差别主要体现在需要的时间上，对于实际的使用不能产生比较的区别，~~编译的时间长一点还可以去摸鱼~~。

而对于内存的需求就比较大了，目前一般的IDE(集成开发环境)一打开就会吃掉1G以上的内存，项目越复杂还可能更大，而且在写代码的同时还会打开一大堆的浏览器标签页查看资料和文档，众所都周知，目前流行的`chrome`浏览器内核在使用内存上是一点都不吝啬，因此推荐16G起步。

对于显卡，如果不需要在工作之余进行一些手脑协调训练，那么亮机卡或者核显就是不错的选择，对于写代码的人来说，高U低显才是合适的搭配。

之于硬盘，写代码对于硬盘的占用也不算是太大，代码文件基本上都是文本文件，不会占用太多的空间。占用比较大的IDE也一般都在10G以下，~~比起一些学习资料小很多了~~一般512G的固态硬盘就完全足够了。 

之于屏幕，作为大多数的学习活动都在电脑上进行的专业，把钱花在一块素质良好的屏幕上是完全值得的。与游戏电竞不同的是，在选择屏幕是应该更看重分辨率而不是刷新率，刷新率在60Hz就完全足够了，如果是笔记本较低的刷新率还有助于降低耗电量，增加续航。

## 我用啥配置

作为一名眼脑协调训练热爱者的我，目前手持的笔记本自然是一台正宗的游戏本——Dell G15 5511，这台笔记本的详细配置如下所示：

- i7-11800H
- 16G DDR4 3200
- RTX3060(125W)
- 512G SSD + 1T SSD（自行添加）
- 1080P 165Hz 屏幕

下面简单谈谈对于我而言，这台电脑的优势和劣势：

### 优势

- 强大的性能使我的游戏体验还是十分不错的
- 有一个硬盘位可以自行扩展以存放学习资料
- 内存不是板载，在后期内存成为瓶颈时可以扩展
- 拥有数量众多的接口

### 劣势

- 离电续航较短，在某次考试中由于没有占到有插座的座位而不得不使用核显+60Hz+低亮度来完成2个小时的考试。
- 旅行重量比较大，官方标称重量2.81千克，再加上一块板砖充电器，带着它出门的体验一言难尽，简直是锻炼身体的必备利器。
- 风扇的噪音比较大，在图书馆里使用可能给你带来一些尴尬。

### 优化

> 如果我是今年毕业，我一定选台式机+轻薄本的组合，去年硬件市场的行情打消了我这个蓄谋已久的想法

我目前的打算自己再攒一台锐龙6000系轻薄本出来用，否则随着后面专业课程的增加，需要用到笔记本的场景只会越来越多，如果仍然像现在一样几乎限制在寝室里使用，难以为继。毕竟众所都周知啊，寝室并不是一个理想的学习环境，如果想要沉浸式的学习，还是得去图书馆和教室。

## 给后来者的建议

- 如果你不玩游戏，那么一台性能释放较好的核显轻薄本就是你最好的选择。短时间强大的性能释放足够帮你应付编译等场景下的性能需求，轻薄本不错的续航和较轻的重量又能保证你在学校中能够相对自由的移动
- 如果你玩游戏，那么还是顺从自己的内心使用游戏本吧！否则你看见同寝室友愉快玩耍时，也会生出再买一台电脑的念头。
- 如果你不确定或者有点小钱，也可以选择轻薄本加台式机的组合，这也是最让人感到舒适的配置组合，兼具轻薄本的灵活性和台式机的高性能，唯一的缺点是贵，不过那算是我的缺点
- 内存保底16G，如果能更大当然更好
- 屏幕素质可以选择的高一些
- 如果你已经确定自己要选购一台台式机，请确保自己未来就读的学校有足够的空间和供电来确保自己可以愉快的玩耍，否则不要买了轻薄本到了学校傻了眼，“这小破地方怎么放台式机啊”，或者是游戏一开全寝断电
